<template>
  <div class="row justify-content-center">
    <div class="col-8">
      <form name="editForm" role="form" novalidate v-on:submit.prevent="save()">
        <h2
          id="coopcycleApp.produit.home.createOrEditLabel"
          data-cy="ProduitCreateUpdateHeading"
          v-text="$t('coopcycleApp.produit.home.createOrEditLabel')"
        >
          Create or edit a Produit
        </h2>
        <div>
          <div class="form-group" v-if="produit.id">
            <label for="id" v-text="$t('global.field.id')">ID</label>
            <input type="text" class="form-control" id="id" name="id" v-model="produit.id" readonly />
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.produit.idProduit')" for="produit-idProduit">Id Produit</label>
            <input
              type="number"
              class="form-control"
              name="idProduit"
              id="produit-idProduit"
              data-cy="idProduit"
              :class="{ valid: !$v.produit.idProduit.$invalid, invalid: $v.produit.idProduit.$invalid }"
              v-model.number="$v.produit.idProduit.$model"
              required
            />
            <div v-if="$v.produit.idProduit.$anyDirty && $v.produit.idProduit.$invalid">
              <small class="form-text text-danger" v-if="!$v.produit.idProduit.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
              <small class="form-text text-danger" v-if="!$v.produit.idProduit.numeric" v-text="$t('entity.validation.number')">
                This field should be a number.
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.produit.nomProduit')" for="produit-nomProduit">Nom Produit</label>
            <input
              type="text"
              class="form-control"
              name="nomProduit"
              id="produit-nomProduit"
              data-cy="nomProduit"
              :class="{ valid: !$v.produit.nomProduit.$invalid, invalid: $v.produit.nomProduit.$invalid }"
              v-model="$v.produit.nomProduit.$model"
              required
            />
            <div v-if="$v.produit.nomProduit.$anyDirty && $v.produit.nomProduit.$invalid">
              <small class="form-text text-danger" v-if="!$v.produit.nomProduit.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
              <small
                class="form-text text-danger"
                v-if="!$v.produit.nomProduit.minLength"
                v-text="$t('entity.validation.minlength', { min: 2 })"
              >
                This field is required to be at least 2 characters.
              </small>
              <small
                class="form-text text-danger"
                v-if="!$v.produit.nomProduit.pattern"
                v-text="$t('entity.validation.pattern', { pattern: 'Nom Produit' })"
              >
                This field should follow pattern for "Nom Produit".
              </small>
            </div>
          </div>
          <div class="form-group">
            <label class="form-control-label" v-text="$t('coopcycleApp.produit.prix')" for="produit-prix">Prix</label>
            <input
              type="number"
              class="form-control"
              name="prix"
              id="produit-prix"
              data-cy="prix"
              :class="{ valid: !$v.produit.prix.$invalid, invalid: $v.produit.prix.$invalid }"
              v-model.number="$v.produit.prix.$model"
              required
            />
            <div v-if="$v.produit.prix.$anyDirty && $v.produit.prix.$invalid">
              <small class="form-text text-danger" v-if="!$v.produit.prix.required" v-text="$t('entity.validation.required')">
                This field is required.
              </small>
              <small class="form-text text-danger" v-if="!$v.produit.prix.numeric" v-text="$t('entity.validation.number')">
                This field should be a number.
              </small>
            </div>
          </div>
          <div class="form-group">
            <label v-text="$t('coopcycleApp.produit.estComposeDe')" for="produit-estComposeDe">Est Compose De</label>
            <select
              class="form-control"
              id="produit-estComposeDes"
              data-cy="estComposeDe"
              multiple
              name="estComposeDe"
              v-if="produit.estComposeDes !== undefined"
              v-model="produit.estComposeDes"
            >
              <option
                v-bind:value="getSelected(produit.estComposeDes, panierOption)"
                v-for="panierOption in paniers"
                :key="panierOption.id"
              >
                {{ panierOption.id }}
              </option>
            </select>
          </div>
        </div>
        <div>
          <button type="button" id="cancel-save" data-cy="entityCreateCancelButton" class="btn btn-secondary" v-on:click="previousState()">
            <font-awesome-icon icon="ban"></font-awesome-icon>&nbsp;<span v-text="$t('entity.action.cancel')">Cancel</span>
          </button>
          <button
            type="submit"
            id="save-entity"
            data-cy="entityCreateSaveButton"
            :disabled="$v.produit.$invalid || isSaving"
            class="btn btn-primary"
          >
            <font-awesome-icon icon="save"></font-awesome-icon>&nbsp;<span v-text="$t('entity.action.save')">Save</span>
          </button>
        </div>
      </form>
    </div>
  </div>
</template>
<script lang="ts" src="./produit-update.component.ts"></script>
